import threading
import time
import random

s = threading.Semaphore(1)
n = threading.Semaphore(0)

class Buffer:
    def __init__(self):
        self.b = [0 for i in range(1000)]
        self.point_in = 0
        self.point_out = 0

    def append(self, v):
        self.b[self.point_in] = v
        self.point_in += 1

    def take(self):
        if self.point_in == self.point_out:
            raise Exception("Internal error: take should never be called when the buffer is empty")
        self.point_out += 1
        return self.b[self.point_out - 1]
        
def produce():
    time.sleep(1)
    return random.randint(1, 10)

def consume(v):
    time.sleep(1)

def producer(i):
    global b
    v = produce()
    s.acquire()
    print("Il produttore %d e' nella sezione critica" %(i))
    b.append(v)
    s.release()
    n.release()

def consumer(i):
    global b
    n.acquire()
    s.acquire()
    print("Il consumatore %d e' nella sezione critica" %(i))
    v = b.take()
    s.release()
    consume(v)

tests = []
tests += [[(0, producer if i%2 == 0 else consumer, i) for i in range(20)]]

for i in range(len(tests)):
    t = []
    b = Buffer()
    for j in range(len(tests[i])):
        test = tests[i][j]
        time.sleep(test[0])
        t += [threading.Thread(target=(test[1]), args=[test[2]])]
        t[-1].start()
    for j in range(len(tests[i])):
        t[j].join()
    print("test %d finished!" %i)
